Index: pplinux/linuxnew/drivers/mtd/mtdcore.c
diff -u pplinux/linuxnew/drivers/mtd/mtdcore.c:1.1.323.1 pplinux/linuxnew/drivers/mtd/mtdcore.c:1.3
--- pplinux/linuxnew/drivers/mtd/mtdcore.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/mtdcore.c	Wed Apr  6 11:53:11 2005
@@ -21,6 +21,9 @@
 #ifdef CONFIG_PROC_FS
 #include <linux/proc_fs.h>
 #endif
+#ifdef CONFIG_PEPPERCON
+# include "asm/ibm4xx.h"
+#endif
 
 #include <linux/mtd/mtd.h>
 
@@ -362,6 +365,160 @@
         return ((count < begin+len-off) ? count : begin+len-off);
 }
 
+#ifdef CONFIG_PEPPERCON
+static int mtd_read_proc_size( char *page, char **start, off_t off,int count,
+			       int *eof, void *data_unused)
+{
+	int len;
+
+	bd_t * bd = (bd_t *)__res;
+	len = sprintf(page, "%ld\n", bd->bi_flashsize / (1024 * 1024));
+	
+        *eof = 1;
+
+	*start = NULL;
+        return len;
+}
+
+static int mtd_read_proc_prot_fact( char *page, char **start, off_t off, int count,
+				    int *eof, void *data_unused)
+{
+#if defined(PRODUCT_FLASHX4)
+    struct mtd_info *mtd = get_mtd_device(NULL, 6);
+#else
+    struct mtd_info *mtd = get_mtd_device(NULL, 0);
+#endif
+	int len = 0, i, ret;
+	u_char buf[8]; size_t retlen;
+
+	if (mtd == NULL) {
+	    goto done;
+	}
+
+	memset(buf, 0, sizeof(buf));
+	ret = mtd->read_fact_prot_reg(mtd, 0, 8, &retlen, buf);
+	for (i=0; i<8; i++) {
+	    len += sprintf(&page[len], "%02X", buf[i]);
+	}
+	
+	put_mtd_device(mtd);
+done:
+	*eof = 1;
+	len += sprintf(&page[len], "\n");
+	*start = NULL;
+        return len;
+}
+
+static int mtd_read_proc_prot_user( char *page, char **start, off_t off, int count,
+				    int *eof, void *data_unused)
+{
+#if defined(PRODUCT_FLASHX4)
+    struct mtd_info *mtd = get_mtd_device(NULL, 6);
+#else
+    struct mtd_info *mtd = get_mtd_device(NULL, 0);
+#endif
+	int len = 0, i, ret;
+	u_char buf[8]; size_t retlen;
+
+	if (mtd == NULL) {
+	    goto done;
+	}
+
+	memset(buf, 0, sizeof(buf));
+	ret = mtd->read_user_prot_reg(mtd, 0, 8, &retlen, buf);
+	for (i=0; i<8; i++) {
+	    len += sprintf(&page[len], "%02X", buf[i]);
+	}
+	
+	put_mtd_device(mtd);
+done:
+        *eof = 1;
+	len += sprintf(&page[len], "\n");
+	*start = NULL;
+        return len;
+}
+
+static int mtd_write_proc_prot_user(struct file *file, const char *buffer,
+				    unsigned long count, void *data)
+{
+#if defined(PRODUCT_FLASHX4)
+    struct mtd_info *mtd = get_mtd_device(NULL, 6);
+#else
+    struct mtd_info *mtd = get_mtd_device(NULL, 0);
+#endif
+	int i;
+	u_char buf[8], number[2];
+	size_t retlen, len = count;
+
+	if (mtd == NULL || count == 0) {
+	    goto done;
+	}
+
+	if (buffer[count - 1] == '\n') {
+	    len = count - 1;
+	}
+
+	for (i = 0; i < len / 2; i++) {
+	    memcpy(number, &buffer[2 * i], 2);
+	    buf[i] = simple_strtol(number, NULL, 16);
+	}
+
+	mtd->write_user_prot_reg(mtd, 0, len / 2, &retlen, buf);
+
+	put_mtd_device(mtd);
+ done:
+	return count;
+}
+
+static int mtd_read_proc_prot_lock(char *page, char **start, off_t off, int count,
+				   int *eof, void *data_unused)
+{
+#if defined(PRODUCT_FLASHX4)
+    struct mtd_info *mtd = get_mtd_device(NULL, 6);
+#else
+    struct mtd_info *mtd = get_mtd_device(NULL, 0);
+#endif
+    int len = 0;
+
+    if (mtd == NULL) {
+	goto done;
+    }
+    
+    len += sprintf(&page[len], "%d", mtd->is_user_prot_reg_locked(mtd));
+
+    put_mtd_device(mtd);
+ done:
+    *eof = 1;
+    len += sprintf(&page[len], "\n");
+    *start = NULL;
+    return len;
+}
+
+static int mtd_write_proc_prot_lock(struct file *file, const char *buffer,
+				    unsigned long count, void *data)
+{
+#if defined(PRODUCT_FLASHX4)
+    struct mtd_info *mtd = get_mtd_device(NULL, 6);
+#else
+    struct mtd_info *mtd = get_mtd_device(NULL, 0);
+#endif
+    int lock;
+
+    if (mtd == NULL || count == 0) {
+	goto done;
+    }
+
+    lock = simple_strtol(buffer, NULL, 10);
+    if (lock) {
+	mtd->lock_user_prot_reg(mtd);
+    }	
+    
+    put_mtd_device(mtd);
+ done:
+    return count;
+}
+#endif
+
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,2,0)
 struct proc_dir_entry mtd_proc_entry = {
         0,                 /* low_ino: the inode -- dynamic */
@@ -385,6 +542,25 @@
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,2,0)
 	if ((proc_mtd = create_proc_entry( "mtd", 0, 0 )))
 	  proc_mtd->read_proc = mtd_read_proc;
+# ifdef CONFIG_PEPPERCON
+	if ((proc_mtd = create_proc_entry( "mtd_size_mb", 0, 0 ))) {
+	  proc_mtd->read_proc = mtd_read_proc_size;
+	}
+
+	if ((proc_mtd = create_proc_entry( "mtd_prot_fact", 0, 0 ))) {
+	    proc_mtd->read_proc = mtd_read_proc_prot_fact;
+	}
+	
+	if ((proc_mtd = create_proc_entry( "mtd_prot_user", 0, 0 ))) {
+	    proc_mtd->read_proc = mtd_read_proc_prot_user;
+	    proc_mtd->write_proc = mtd_write_proc_prot_user;
+	}
+	
+	if ((proc_mtd = create_proc_entry( "mtd_prot_lock", 0, 0 ))) {
+	    proc_mtd->read_proc = mtd_read_proc_prot_lock;
+	    proc_mtd->write_proc = mtd_write_proc_prot_lock;
+	}
+# endif
 #else
         proc_register_dynamic(&proc_root,&mtd_proc_entry);
 #endif
Index: pplinux/linuxnew/drivers/mtd/mtdpart.c
diff -u pplinux/linuxnew/drivers/mtd/mtdpart.c:1.1.323.1 pplinux/linuxnew/drivers/mtd/mtdpart.c:1.3
--- pplinux/linuxnew/drivers/mtd/mtdpart.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/mtdpart.c	Wed Apr  6 11:53:11 2005
@@ -113,10 +113,22 @@
 			size_t *retlen, u_char *buf)
 {
 	struct mtd_part *part = PART(mtd);
-	return part->master->read_user_prot_reg (part->master, from, 
+	return part->master->read_fact_prot_reg (part->master, from, 
 					len, retlen, buf);
 }
 
+static int part_lock_user_prot_reg (struct mtd_info *mtd)
+{
+	struct mtd_part *part = PART(mtd);
+	return part->master->lock_user_prot_reg (part->master);
+}
+
+static int part_is_user_prot_reg_locked (struct mtd_info *mtd)
+{
+	struct mtd_part *part = PART(mtd);
+	return part->master->is_user_prot_reg_locked (part->master);
+}
+
 static int part_write (struct mtd_info *mtd, loff_t to, size_t len,
 			size_t *retlen, const u_char *buf)
 {
@@ -319,6 +331,10 @@
 		slave->mtd.ecctype = master->ecctype;
 		slave->mtd.eccsize = master->eccsize;
 
+#if defined(PRODUCT_FLASHX4)		
+		slave->mtd.chip_size = master->chip_size;
+#endif		
+		
 		slave->mtd.name = parts[i].name;
 		slave->mtd.bank_size = master->bank_size;
 		slave->mtd.module = master->module;
@@ -345,6 +361,11 @@
 			slave->mtd.read_fact_prot_reg = part_read_fact_prot_reg;
 		if(master->write_user_prot_reg)
 			slave->mtd.write_user_prot_reg = part_write_user_prot_reg;
+		if(master->lock_user_prot_reg)
+			slave->mtd.lock_user_prot_reg = part_lock_user_prot_reg;
+		if(master->is_user_prot_reg_locked)
+			slave->mtd.is_user_prot_reg_locked = part_is_user_prot_reg_locked;
+
 		if (master->sync)
 			slave->mtd.sync = part_sync;
 		if (!i && master->suspend && master->resume) {
Index: pplinux/linuxnew/drivers/mtd/chips/cfi_cmdset_0001.c
diff -u pplinux/linuxnew/drivers/mtd/chips/cfi_cmdset_0001.c:1.1.323.1 pplinux/linuxnew/drivers/mtd/chips/cfi_cmdset_0001.c:1.3
--- pplinux/linuxnew/drivers/mtd/chips/cfi_cmdset_0001.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/chips/cfi_cmdset_0001.c	Wed Apr  6 11:53:11 2005
@@ -15,7 +15,7 @@
  *	- optimized write buffer method
  * 02/05/2002	Christopher Hoover <ch@hpl.hp.com>/<ch@murgatroid.com>
  *	- reworked lock/unlock/erase support for var size flash
- */
+*/
 
 #include <linux/module.h>
 #include <linux/types.h>
@@ -32,11 +32,21 @@
 #include <linux/mtd/cfi.h>
 #include <linux/mtd/compatmac.h>
 
+typedef enum {
+    PROT_REGOP_READ,
+    PROT_REGOP_WRITE
+} prot_regop_t;
+
 // debugging, turns off buffer write mode #define FORCE_WORD_WRITE
 
 static int cfi_intelext_read (struct mtd_info *, loff_t, size_t, size_t *, u_char *);
+static int cfi_intelext_prot_regop(struct mtd_info *mtd, prot_regop_t regop, loff_t from, size_t len,
+				   size_t *retlen, u_char *buf, int base_offst, int reg_sz);
 static int cfi_intelext_read_user_prot_reg (struct mtd_info *, loff_t, size_t, size_t *, u_char *);
 static int cfi_intelext_read_fact_prot_reg (struct mtd_info *, loff_t, size_t, size_t *, u_char *);
+static int cfi_intelext_write_user_prot_reg (struct mtd_info *, loff_t, size_t, size_t *, u_char *);
+static int cfi_intelext_lock_user_prot_reg (struct mtd_info *);
+static int cfi_intelext_is_user_prot_reg_locked (struct mtd_info *);
 static int cfi_intelext_write_words(struct mtd_info *, loff_t, size_t, size_t *, const u_char *);
 static int cfi_intelext_write_buffers(struct mtd_info *, loff_t, size_t, size_t *, const u_char *);
 static int cfi_intelext_erase_varsize(struct mtd_info *, struct erase_info *);
@@ -106,6 +116,14 @@
 	if (extp->VppOptimal)
 		printk("  Vpp Programming Supply Optimum Program/Erase Voltage: %d.%d V\n", 
 		       extp->VppOptimal >> 8, extp->VppOptimal & 0xf);
+
+	if (extp->FeatureSupport&64) {
+	    printk("  Protection Description\n");
+	    printk("     - NumProtectionFields: %d\n", extp->NumProtectionFields);
+	    printk("     - ProtRegAddr:         %d\n", extp->ProtRegAddr);
+	    printk("     - FactProtRegSize:     %d\n", 1 << extp->FactProtRegSize);
+	    printk("     - UserProtRegSize:     %d\n", 1 << extp->UserProtRegSize);
+	}
 }
 #endif
 
@@ -120,6 +138,10 @@
 {
 	struct cfi_private *cfi = map->fldrv_priv;
 	int i;
+#if defined(PRODUCT_FLASHX4)
+	int b;
+#endif	
+	
 	__u32 base = cfi->chips[0].start;
 
 	if (cfi->cfi_mode == CFI_MODE_CFI) {
@@ -164,7 +186,19 @@
 		extp->FeatureSupport = le32_to_cpu(extp->FeatureSupport);
 		extp->BlkStatusRegMask = le16_to_cpu(extp->BlkStatusRegMask);
 		extp->ProtRegAddr = le16_to_cpu(extp->ProtRegAddr);
-			
+
+#ifdef CONFIG_PEPPERCON
+# warning Hard coded protection description fields!
+		/*
+		  not sure yet why the flash returns 0 to the extended CFI Query
+		  in the protection description fields, replacing manually
+		  for now
+		 */
+		extp->ProtRegAddr = 0x0080;
+		extp->FactProtRegSize = 3;
+		extp->UserProtRegSize = 3;
+#endif
+
 #ifdef DEBUG_CFI_FEATURES
 		/* Tell the user about it in lots of lovely detail */
 		cfi_tell_features(extp);
@@ -193,7 +227,14 @@
 	}		
 
 	map->fldrv = &cfi_intelext_chipdrv;
-	
+
+#if defined(PRODUCT_FLASHX4)	
+	cfi_send_gen_cmd(0xF0, 0, base, map, cfi, cfi->device_type, NULL);
+	cfi_send_gen_cmd(0x90, 0, base, map, cfi, cfi->device_type, NULL);
+	b = cfi_read(map,0x2);	
+	map->chip_size = b;
+#endif	
+		
 	/* Make sure it's in read mode */
 	cfi_send_gen_cmd(0xff, 0x55, base, map, cfi, cfi->device_type, NULL);
 	return cfi_intelext_setup(map);
@@ -209,7 +250,7 @@
 
 	mtd = kmalloc(sizeof(*mtd), GFP_KERNEL);
 	//printk(KERN_DEBUG "number of CFI chips: %d\n", cfi->numchips);
-
+	
 	if (!mtd) {
 		printk(KERN_ERR "Failed to allocate memory for MTD device\n");
 		goto setup_err;
@@ -218,7 +259,7 @@
 	memset(mtd, 0, sizeof(*mtd));
 	mtd->priv = map;
 	mtd->type = MTD_NORFLASH;
-	mtd->size = devsize * cfi->numchips;
+	mtd->size = devsize * cfi->numchips;	
 
 	mtd->numeraseregions = cfi->cfiq->NumEraseRegions * cfi->numchips;
 	mtd->eraseregions = kmalloc(sizeof(struct mtd_erase_region_info) 
@@ -277,8 +318,14 @@
 		printk("Using word write method\n" );
 		mtd->write = cfi_intelext_write_words;
 	}
+
+	/* protection register access */
 	mtd->read_user_prot_reg = cfi_intelext_read_user_prot_reg;
 	mtd->read_fact_prot_reg = cfi_intelext_read_fact_prot_reg;
+	mtd->write_user_prot_reg = cfi_intelext_write_user_prot_reg;
+	mtd->lock_user_prot_reg = cfi_intelext_lock_user_prot_reg;
+	mtd->is_user_prot_reg_locked = cfi_intelext_is_user_prot_reg_locked;
+	
 	mtd->sync = cfi_intelext_sync;
 	mtd->lock = cfi_intelext_lock;
 	mtd->unlock = cfi_intelext_unlock;
@@ -288,6 +335,9 @@
 	map->fldrv = &cfi_intelext_chipdrv;
 	MOD_INC_USE_COUNT;
 	mtd->name = map->name;
+#if defined(PRODUCT_FLASHX4)	
+	mtd->chip_size = map->chip_size;
+#endif
 	return mtd;
 
  setup_err:
@@ -636,7 +686,8 @@
 	return ret;
 }
 
-static int cfi_intelext_read_prot_reg (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf, int base_offst, int reg_sz)
+ static int cfi_intelext_prot_regop(struct mtd_info *mtd, prot_regop_t regop, loff_t from,
+				    size_t len, size_t *retlen, u_char *buf, int base_offst, int reg_sz)
 {
 	struct map_info *map = mtd->priv;
 	struct cfi_private *cfi = map->fldrv_priv;
@@ -648,12 +699,24 @@
 	unsigned long timeo;
 	DECLARE_WAITQUEUE(wait, current);
 
+	/* Check that we actually have some protection registers */
+	if(!(extp->FeatureSupport & 64)){
+	    printk(KERN_WARNING "%s: This flash device has no protection data to read!\n",map->name);
+	    return 0;
+	}
+
+	if (regop != PROT_REGOP_READ &&
+	    regop != PROT_REGOP_WRITE) {
+	    printk("Unknown protection regop!\n");
+	    goto out;    
+	}
+
 	chip=0;
 	/* Calculate which chip & protection register offset we need */
 	chip_num=((unsigned int)from/reg_sz);
 	offst=from-(reg_sz*chip_num)+base_offst;
 
-	while(count){
+	while (count >= 0) {
 		
 		if(chip_num>=cfi->numchips)
 			goto out;
@@ -683,23 +746,60 @@
 			timeo = jiffies + HZ;
 			goto retry;
 		}
-			
-		/* Now read the data required from this flash */
-       
-		cfi_send_gen_cmd(0x90, 0x55,chip->start, map, cfi, cfi->device_type, NULL);
-		while(count && ((offst-base_offst)<reg_sz)){
-			*buf=map->read8(map,(chip->start+((extp->ProtRegAddr+1)*ofs_factor)+offst));
+
+		/* Now access the appropriate protection register data */
+		if (regop == PROT_REGOP_READ) {
+		    cfi_send_gen_cmd(0x90, 0x55, chip->start, map, cfi, cfi->device_type, NULL);	
+
+		    while(count && ((offst-base_offst)<reg_sz)){
+			*buf=map->read8(map, (chip->start+(extp->ProtRegAddr*ofs_factor)+offst));
+			//printk("Read %02x from %04x\n", *buf, (chip->start+(extp->ProtRegAddr*ofs_factor)+offst));
 			buf++;
 			offst++;
 			count--;
+		    }
+
+		} else {
+		    int s;
+		    
+		    while(count && ((offst-base_offst)<reg_sz)) {
+			u_int16_t val;
+			unsigned long timeo;
+
+			if (count == 1) {
+			    // its the last byte, zero the other
+			    val = (u_int16_t) *buf;
+			} else {
+			    val = *((u_int16_t*)buf);
+			}
+
+			//printk("Writing %04x to %04x\n", val, (chip->start+(extp->ProtRegAddr*ofs_factor)+offst));
+			
+			map->write8(map, CMD(0xC0), 0x55);
+			map->write16(map, val, (chip->start+(extp->ProtRegAddr*ofs_factor)+offst));
+
+			timeo = jiffies + HZ;
+			map->write8(map, CMD(0x70), 0x55);
+			while (((s = map->read8(map, 0x55)) & 0x80) == 0) {
+			    if (time_after(jiffies, timeo)) {
+				spin_unlock(chip->mutex);
+				printk(KERN_ERR "waiting for chip to be ready timed out during write\n");
+				goto out;
+			    }
+			}
+			
+			buf   +=2;
+			offst +=2;
+			count -=2;
+		    }
 		}
-	       
+
 		chip->state=FL_CFI_QUERY;
 		spin_unlock(chip->mutex);
+		
 		/* Move on to the next chip */
 		chip_num++;
-		offst=base_offst;
-	
+		offst=base_offst;	
 	}
 	
  out:	
@@ -713,17 +813,11 @@
 	struct cfi_private *cfi = map->fldrv_priv;
 	struct cfi_pri_intelext *extp=cfi->cmdset_priv;
 	int base_offst,reg_sz;
-	
-	/* Check that we actually have some protection registers */
-	if(!(extp->FeatureSupport&64)){
-		printk(KERN_WARNING "%s: This flash device has no protection data to read!\n",map->name);
-		return 0;
-	}
-
-	base_offst=(1<<extp->FactProtRegSize);
+	       
+	base_offst=(1<<extp->FactProtRegSize) + 2;
 	reg_sz=(1<<extp->UserProtRegSize);
 
-	return cfi_intelext_read_prot_reg(mtd, from, len, retlen, buf, base_offst, reg_sz);
+	return cfi_intelext_prot_regop(mtd, PROT_REGOP_READ, from, len, retlen, buf, base_offst, reg_sz);
 }
 
 static int cfi_intelext_read_fact_prot_reg (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf)
@@ -733,20 +827,57 @@
 	struct cfi_pri_intelext *extp=cfi->cmdset_priv;
 	int base_offst,reg_sz;
 	
-	/* Check that we actually have some protection registers */
-	if(!(extp->FeatureSupport&64)){
-		printk(KERN_WARNING "%s: This flash device has no protection data to read!\n",map->name);
-		return 0;
+	base_offst=2;
+	reg_sz=(1<<extp->FactProtRegSize);
+
+	return cfi_intelext_prot_regop(mtd, PROT_REGOP_READ, from, len, retlen, buf, base_offst, reg_sz);
+}
+
+static int cfi_intelext_write_user_prot_reg (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf)
+{
+	struct map_info *map = mtd->priv;
+	struct cfi_private *cfi = map->fldrv_priv;
+	struct cfi_pri_intelext *extp=cfi->cmdset_priv;
+	int base_offst,reg_sz;
+	
+	if (len % 2) {
+	    printk("User protection reg only writable in 16bit increments (Len=%d)\n", len);
+	    return 0;
 	}
 
-	base_offst=0;
-	reg_sz=(1<<extp->FactProtRegSize);
+	base_offst=(1<<extp->FactProtRegSize) + 2;
+	reg_sz=(1<<extp->UserProtRegSize);
 
-	return cfi_intelext_read_prot_reg(mtd, from, len, retlen, buf, base_offst, reg_sz);
+	return cfi_intelext_prot_regop(mtd, PROT_REGOP_WRITE, from, len, retlen, buf, base_offst, reg_sz);
 }
 
+static int cfi_intelext_lock_user_prot_reg (struct mtd_info *mtd)
+{
+    int base_offst, reg_sz, retlen;
+    unsigned short lock = 0xFFFC; 
+
+    base_offst=0;
+    reg_sz=2;
+
+    cfi_intelext_prot_regop(mtd, PROT_REGOP_WRITE, 0, sizeof(lock), &retlen, (u_char*)&lock, base_offst, reg_sz);
+    
+    return 0;
+}
+
+static int cfi_intelext_is_user_prot_reg_locked (struct mtd_info *mtd)
+{
+    int base_offst,reg_sz, retlen;
+    unsigned short lock = 0;
+    
+    base_offst=0;
+    reg_sz=2;
+
+    cfi_intelext_prot_regop(mtd, PROT_REGOP_READ, 0, sizeof(lock), &retlen, (u_char*)&lock, base_offst, reg_sz);
+
+    return (lock == 0xFFFC) ? 1 : 0;
+}
 
-static int do_write_oneword(struct map_info *map, struct flchip *chip, unsigned long adr, cfi_word datum)
+ static int do_write_oneword(struct map_info *map, struct flchip *chip, unsigned long adr, cfi_word datum)
 {
 	struct cfi_private *cfi = map->fldrv_priv;
 	struct cfi_pri_intelext *extp = cfi->cmdset_priv;
Index: pplinux/linuxnew/drivers/mtd/maps/Config.in
diff -u pplinux/linuxnew/drivers/mtd/maps/Config.in:1.1.323.1 pplinux/linuxnew/drivers/mtd/maps/Config.in:1.2
--- pplinux/linuxnew/drivers/mtd/maps/Config.in:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/maps/Config.in	Thu Feb  3 11:35:38 2005
@@ -8,8 +8,10 @@
 
 dep_tristate '  CFI Flash device in physical memory map' CONFIG_MTD_PHYSMAP $CONFIG_MTD_GEN_PROBE
 if [ "$CONFIG_MTD_PHYSMAP" = "y" -o "$CONFIG_MTD_PHYSMAP" = "m" ]; then
+  if [ "$CONFIG_PEPPERCON" != "y" ]; then
    hex '    Physical start address of flash mapping' CONFIG_MTD_PHYSMAP_START 0x8000000
    hex '    Physical length of flash mapping' CONFIG_MTD_PHYSMAP_LEN 0x4000000
+  fi
    int '    Bus width in octets' CONFIG_MTD_PHYSMAP_BUSWIDTH 2
 fi
 
Index: pplinux/linuxnew/drivers/mtd/maps/Makefile
diff -u pplinux/linuxnew/drivers/mtd/maps/Makefile:1.1.323.1 pplinux/linuxnew/drivers/mtd/maps/Makefile:1.3
--- pplinux/linuxnew/drivers/mtd/maps/Makefile:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/maps/Makefile	Wed Apr  6 11:53:11 2005
@@ -32,9 +32,12 @@
   ifeq ($(CONFIG_MTD_PHYSMAP_BUSWIDTH),8)
     obj-$(CONFIG_MTD_PHYSMAP)	+= physmap64.o 
   else
-    obj-$(CONFIG_MTD_PHYSMAP)	+= physmap.o 
+    obj-$(CONFIG_MTD_PHYSMAP)	+= physmap.o
   endif
 endif
+ifeq ($(PP_PRODUCT), flashx4)
+obj-$(CONFIG_MTD_PHYSMAP)	+= physmap_fp.o	
+endif
 obj-$(CONFIG_MTD_PNC2000)	+= pnc2000.o
 obj-$(CONFIG_MTD_PCMCIA)	+= pcmciamtd.o
 obj-$(CONFIG_MTD_RPXLITE)	+= rpxlite.o
Index: pplinux/linuxnew/drivers/mtd/maps/physmap.c
diff -u pplinux/linuxnew/drivers/mtd/maps/physmap.c:1.1.323.1 pplinux/linuxnew/drivers/mtd/maps/physmap.c:1.2
--- pplinux/linuxnew/drivers/mtd/maps/physmap.c:1.1.323.1	Thu Feb  3 10:00:34 2005
+++ pplinux/linuxnew/drivers/mtd/maps/physmap.c	Thu Feb  3 11:35:38 2005
@@ -12,14 +12,22 @@
 #include <linux/mtd/map.h>
 #include <linux/config.h>
 
-#ifdef CONFIG_MTD_PARTITIONS
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
 #include <linux/mtd/partitions.h>
 #endif
 
-#define WINDOW_ADDR CONFIG_MTD_PHYSMAP_START
-#define WINDOW_SIZE CONFIG_MTD_PHYSMAP_LEN
+#ifdef CONFIG_PEPPERCON
+# include "asm/ibm4xx.h"
+# define WINDOW_ADDR bd->bi_flashstart
+# define WINDOW_SIZE bd->bi_flashsize
+#else
+# define WINDOW_ADDR CONFIG_MTD_PHYSMAP_START
+# define WINDOW_SIZE CONFIG_MTD_PHYSMAP_LEN
+#endif
+
 #define BUSWIDTH CONFIG_MTD_PHYSMAP_BUSWIDTH
 
+static char * mtd_id = "phys";
 static struct mtd_info *mymtd;
 
 __u8 physmap_read8(struct map_info *map, unsigned long ofs)
@@ -67,7 +75,6 @@
 
 struct map_info physmap_map = {
 	name: "Physically mapped flash",
-	size: WINDOW_SIZE,
 	buswidth: BUSWIDTH,
 	read8: physmap_read8,
 	read16: physmap_read16,
@@ -76,11 +83,14 @@
 	write8: physmap_write8,
 	write16: physmap_write16,
 	write32: physmap_write32,
-	copy_to: physmap_copy_to
+	copy_to: physmap_copy_to,
+#ifndef CONFIG_PEPPERCON
+	size: WINDOW_SIZE,
+#endif
 };
 
-#ifdef CONFIG_MTD_PARTITIONS
-#ifdef CONFIG_MTD_CMDLINE_PARTS
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+#if defined(CONFIG_MTD_CMDLINE_PARTS) || defined(CONFIG_MTD_CMDLINE_PARTS_MODULE)
 static struct mtd_partition *mtd_parts = 0;
 static int                   mtd_parts_nb = 0;
 #else
@@ -120,7 +130,14 @@
 	static const char *rom_probe_types[] = { "cfi_probe", "jedec_probe", "map_rom", 0 };
 	const char **type;
 
-       	printk(KERN_NOTICE "physmap flash device: %x at %x\n", WINDOW_SIZE, WINDOW_ADDR);
+#ifdef CONFIG_PEPPERCON
+	/* we determine flash address and size
+	   dynamically from board info */
+	bd_t * bd = (bd_t *)__res;
+	physmap_map.size = WINDOW_SIZE;
+#endif	
+	
+       	printk(KERN_NOTICE "physmap flash device: %lx at %lx\n", WINDOW_SIZE, WINDOW_ADDR);
 	physmap_map.map_priv_1 = (unsigned long)ioremap(WINDOW_ADDR, WINDOW_SIZE);
 
 	if (!physmap_map.map_priv_1) {
@@ -136,11 +153,10 @@
 	if (mymtd) {
 		mymtd->module = THIS_MODULE;
 
-		add_mtd_device(mymtd);
-#ifdef CONFIG_MTD_PARTITIONS
-#ifdef CONFIG_MTD_CMDLINE_PARTS
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+#if defined(CONFIG_MTD_CMDLINE_PARTS) || defined(CONFIG_MTD_CMDLINE_PARTS_MODULE)
 		mtd_parts_nb = parse_cmdline_partitions(mymtd, &mtd_parts, 
-							"phys");
+							mtd_id);
 		if (mtd_parts_nb > 0)
 		{
 			printk(KERN_NOTICE 
@@ -156,6 +172,8 @@
 		}
 
 #endif
+#else
+		add_mtd_device(mymtd);
 #endif
 		return 0;
 	}
@@ -167,7 +185,11 @@
 static void __exit cleanup_physmap(void)
 {
 	if (mymtd) {
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+		del_mtd_partitions(mymtd);
+#else
 		del_mtd_device(mymtd);
+#endif
 		map_destroy(mymtd);
 	}
 	if (physmap_map.map_priv_1) {
@@ -179,6 +201,10 @@
 module_init(init_physmap);
 module_exit(cleanup_physmap);
 
+#if defined(CONFIG_MTD_PARTITIONS_MODULE) && defined(CONFIG_MTD_CMDLINE_PARTS_MODULE)
+MODULE_PARM(mtd_id, "s");
+MODULE_PARM_DESC(mtd_id, "Select mtd_id");
+#endif
 
 MODULE_LICENSE("GPL");
 MODULE_AUTHOR("David Woodhouse <dwmw2@infradead.org>");
Index: pplinux/linuxnew/drivers/mtd/maps/physmap_fp.c
diff -u /dev/null pplinux/linuxnew/drivers/mtd/maps/physmap_fp.c:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/drivers/mtd/maps/physmap_fp.c	Wed Apr  6 11:53:11 2005
@@ -0,0 +1,218 @@
+/*
+ * $Id: physmap_fp.c,v 1.1 2005/04/06 09:53:11 rwa Exp $
+ *
+ * Normal mappings of chips in physical memory
+ */
+
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <asm/io.h>
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/config.h>
+
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+#include <linux/mtd/partitions.h>
+#endif
+
+#ifdef CONFIG_PEPPERCON
+# include "asm/ibm4xx.h"
+# define WINDOW_ADDR 0xf1000000
+# define WINDOW_SIZE mtd_size
+#else
+# define WINDOW_ADDR CONFIG_MTD_PHYSMAP_START
+# define WINDOW_SIZE CONFIG_MTD_PHYSMAP_LEN
+#endif
+
+#define BUSWIDTH CONFIG_MTD_PHYSMAP_BUSWIDTH
+
+static char * mtd_id = "phys";
+static long   mtd_size = 0x800000;
+
+static struct mtd_info *mymtd;
+
+__u8 physmap_fp_read8(struct map_info *map, unsigned long ofs)
+{
+    return __raw_readb(map->map_priv_1 + ofs);
+}
+
+__u16 physmap_fp_read16(struct map_info *map, unsigned long ofs)
+{ 
+    return __raw_readw(map->map_priv_1 + ofs);
+}
+
+__u32 physmap_fp_read32(struct map_info *map, unsigned long ofs)
+{
+    return __raw_readl(map->map_priv_1 + ofs);
+}
+
+void physmap_fp_copy_from(struct map_info *map, void *to, unsigned long from, ssize_t len)
+{
+    memcpy_fromio(to, map->map_priv_1 + from, len);
+}
+
+void physmap_fp_write8(struct map_info *map, __u8 d, unsigned long adr)
+{
+    __raw_writeb(d, map->map_priv_1 + adr);
+    mb();
+}
+
+void physmap_fp_write16(struct map_info *map, __u16 d, unsigned long adr)
+{
+    __raw_writew(d, map->map_priv_1 + adr);
+    mb();
+}
+
+void physmap_fp_write32(struct map_info *map, __u32 d, unsigned long adr)
+{
+    __raw_writel(d, map->map_priv_1 + adr);
+    mb();
+}
+
+void physmap_fp_copy_to(struct map_info *map, unsigned long to, const void *from, ssize_t len)
+{
+    memcpy_toio(map->map_priv_1 + to, from, len);
+}
+
+struct map_info physmap_fp_map = {
+	name: "Physically mapped flash",
+	buswidth: BUSWIDTH,
+	read8: physmap_fp_read8,
+	read16: physmap_fp_read16,
+	read32: physmap_fp_read32,
+	copy_from: physmap_fp_copy_from,
+	write8: physmap_fp_write8,
+	write16: physmap_fp_write16,
+	write32: physmap_fp_write32,
+	copy_to: physmap_fp_copy_to,
+#ifndef CONFIG_PEPPERCON
+	size: WINDOW_SIZE,
+#endif
+};
+
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+#if defined(CONFIG_MTD_CMDLINE_PARTS) || defined(CONFIG_MTD_CMDLINE_PARTS_MODULE)
+static struct mtd_partition *mtd_parts = 0;
+static int                   mtd_parts_nb = 0;
+#else
+static struct mtd_partition physmap_partitions[] = {
+/* Put your own partition definitions here */
+#if 0
+	{
+		name:		"bootROM",
+		size:		0x80000,
+		offset:		0,
+		mask_flags:	MTD_WRITEABLE,  /* force read-only */
+	}, {
+		name:		"zImage",
+		size:		0x100000,
+		offset:		MTDPART_OFS_APPEND,
+		mask_flags:	MTD_WRITEABLE,  /* force read-only */
+	}, {
+		name:		"ramdisk.gz",
+		size:		0x300000,
+		offset:		MTDPART_OFS_APPEND,
+		mask_flags:	MTD_WRITEABLE,  /* force read-only */
+	}, {
+		name:		"User FS",
+		size:		MTDPART_SIZ_FULL,
+		offset:		MTDPART_OFS_APPEND,
+	}
+#endif
+};
+
+#define NUM_PARTITIONS	(sizeof(physmap_partitions)/sizeof(struct mtd_partition))
+
+#endif
+#endif
+
+int __init init_physmap_fp(void)
+{
+	static const char *rom_probe_types[] = { "cfi_probe", "jedec_probe", "map_rom", 0 };
+	const char **type;
+
+#ifdef CONFIG_PEPPERCON
+	/* we determine flash address and size
+	   dynamically from board info */
+	//bd_t * bd = (bd_t *)__res;
+	physmap_fp_map.size = mtd_size;
+#endif	
+	
+       	printk(KERN_NOTICE "physmap flash device: %lx at %lx\n", mtd_size, WINDOW_ADDR);
+	physmap_fp_map.map_priv_1 = (unsigned long)ioremap(WINDOW_ADDR, mtd_size);
+
+	if (!physmap_fp_map.map_priv_1) {
+		printk("Failed to ioremap\n");
+		return -EIO;
+	}
+
+	mymtd = 0;
+	type = rom_probe_types;
+	for(; !mymtd && *type; type++) {
+		mymtd = do_map_probe(*type, &physmap_fp_map);
+	}
+
+	if (mymtd) {
+		mymtd->module = THIS_MODULE;
+
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+#if defined(CONFIG_MTD_CMDLINE_PARTS) || defined(CONFIG_MTD_CMDLINE_PARTS_MODULE)
+		mtd_parts_nb = parse_cmdline_partitions(mymtd, &mtd_parts, 
+							mtd_id);
+
+		if (mtd_parts_nb > 0)
+		{
+			printk(KERN_NOTICE 
+			       "Using command line partition definition\n");
+			
+			add_mtd_partitions (mymtd, mtd_parts, mtd_parts_nb);
+		}
+#else
+		if (NUM_PARTITIONS != 0) 
+		{
+			printk(KERN_NOTICE 
+			       "Using physmap partition definition\n");
+			add_mtd_partitions (mymtd, physmap_partitions, NUM_PARTITIONS);
+		}
+
+#endif
+#else
+		add_mtd_device(mymtd);
+#endif
+		return 0;
+	}
+	iounmap((void *)physmap_fp_map.map_priv_1);
+	return -ENXIO;
+}
+
+static void __exit cleanup_physmap_fp(void)
+{
+	if (mymtd) {
+#if defined(CONFIG_MTD_PARTITIONS) || defined(CONFIG_MTD_PARTITIONS_MODULE)
+		del_mtd_partitions(mymtd);
+#else
+		del_mtd_device(mymtd);
+#endif
+		map_destroy(mymtd);
+	}
+	if (physmap_fp_map.map_priv_1) {
+		iounmap((void *)physmap_fp_map.map_priv_1);
+		physmap_fp_map.map_priv_1 = 0;
+	}
+}
+
+module_init(init_physmap_fp);
+module_exit(cleanup_physmap_fp);
+
+#if defined(CONFIG_MTD_PARTITIONS_MODULE) && defined(CONFIG_MTD_CMDLINE_PARTS_MODULE)
+MODULE_PARM(mtd_id, "s");
+MODULE_PARM_DESC(mtd_id, "Select mtd_id");
+MODULE_PARM(mtd_size, "l");
+MODULE_PARM_DESC(mtd_size, "Select flash size");
+#endif
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("David Woodhouse <dwmw2@infradead.org>");
+MODULE_DESCRIPTION("Generic configurable MTD map driver");
+
Index: pplinux/linuxnew/drivers/net/8139too.c
diff -u pplinux/linuxnew/drivers/net/8139too.c:1.1.323.1 pplinux/linuxnew/drivers/net/8139too.c:1.2
--- pplinux/linuxnew/drivers/net/8139too.c:1.1.323.1	Thu Feb  3 10:00:52 2005
+++ pplinux/linuxnew/drivers/net/8139too.c	Thu Feb  3 11:35:38 2005
@@ -124,7 +124,7 @@
 
 /* enable PIO instead of MMIO, if CONFIG_8139TOO_PIO is selected */
 #ifdef CONFIG_8139TOO_PIO
-#define USE_IO_OPS 1
+#error PIO is not possible, only the pci memory is mapped (powerpc - pci bus)
 #endif
 
 /* use a 16K rx ring buffer instead of the default 32K */
